// ScolPlugin.h : Declaration of the CScolPlugin

#ifndef __SCOLPLUGIN_H_
#define __SCOLPLUGIN_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
//#include "GVar.h"
#include "ScolInterface.h"






/////////////////////////////////////////////////////////////////////////////
// CScolPlugin
#include "NewATLScolCP.h"
class ATL_NO_VTABLE CScolPlugin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IScolPlugin, &IID_IScolPlugin, &LIBID_NEWATLSCOLLib>,
	public IProvideClassInfo2Impl <&CLSID_ScolPlugin,&DIID__IScolPluginEvents,&LIBID_NEWATLSCOLLib>,
	public CComControl<CScolPlugin>,
	public IPersistStreamInitImpl<CScolPlugin>,
	public IOleControlImpl<CScolPlugin>,
	public IOleObjectImpl<CScolPlugin>,
	public IOleInPlaceActiveObjectImpl<CScolPlugin>,
	public IViewObjectExImpl<CScolPlugin>,
	public IOleInPlaceObjectWindowlessImpl<CScolPlugin>,
	public CProxy_IScolPluginEvents< CScolPlugin >,		/* Add ConnectionPoint Impl */
	public IConnectionPointContainerImpl<CScolPlugin>,
	public CComCoClass<CScolPlugin, &CLSID_ScolPlugin>,
	  // Ajout Tiry 31/07/2001 : Ajout de l'implementation par dfaut de l'interface IPersistPropertyBag
  // => Permet d'initialiser les proprits  partir de l'environnement du conteneur
	public IPersistStorageImpl<CScolPlugin>,
	public IPersistPropertyBagImpl<CScolPlugin>,		/* Add propertyBag support */
	// Added to Avoid IE Security warning
	public IObjectSafetyImpl <CScolPlugin,INTERFACESAFE_FOR_UNTRUSTED_CALLER|INTERFACESAFE_FOR_UNTRUSTED_DATA>

{
private:
	ScolInterface* MyScolInterface;
public:
	CScolPlugin(void);
	~CScolPlugin(void);
	int SendEndEventToJS(int Reason);
	int SendMessageToJS(char *JSMessage);
	CComBSTR m_bstrScolVersionNeeded;		// Version de Scol ncessaire pour la page Web
	CComBSTR m_bstrDownloadURL;				// URL de telechargement de l'installer
	BOOL m_boolForceInstall;
	long m_longDownloadSize;

DECLARE_REGISTRY_RESOURCEID(IDR_SCOLPLUGIN)
DECLARE_NOT_AGGREGATABLE(CScolPlugin)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CScolPlugin)
	COM_INTERFACE_ENTRY(IScolPlugin)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
// Removed by Tiry because of COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
//	COM_INTERFACE_ENTRY(IConnectionPointContainer)

// Ajout Tiry : Ajout de l'interface IPersistPropertyBag
	COM_INTERFACE_ENTRY_IMPL_IID(IID_IPersist, IPersistPropertyBag)
	COM_INTERFACE_ENTRY_IMPL(IPersistPropertyBag)

// Ajout Tiry :  Ajout de IProvideClassInfo pour la gestion des evnements dans IE
// Les env de script (tel IE) utilise IProvideClassInfo pour obtenir la bibliothque de type
// en dduire les vnements  utiliser : cette interface est inutile depuis VB
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROP_MAP(CScolPlugin)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
// Ajout des proprits pouvant tre initialises directement 
// depuis le TAG OBJECT via le tag <PARAM
	PROP_ENTRY("DownloadURL", 3, CLSID_ScolPlugin)
	PROP_ENTRY("DownloadSize", 6, CLSID_ScolPlugin)
	PROP_ENTRY("ScolVersionNeeded", 2, CLSID_ScolPlugin)
	PROP_ENTRY("ForceInstall", 5, CLSID_ScolPlugin)
END_PROP_MAP()

// Gestion des evnements
BEGIN_CONNECTION_POINT_MAP(CScolPlugin)
	CONNECTION_POINT_ENTRY(DIID__IScolPluginEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CScolPlugin)
	CHAIN_MSG_MAP(CComControl<CScolPlugin>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IScolPlugin
public:
	STDMETHOD(get_DownloadSize)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_DownloadSize)(/*[in]*/ long newVal);
	STDMETHOD(get_ForceInstall)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_ForceInstall)(/*[in]*/ BOOL newVal);
	STDMETHOD(SendMessage)(/*[in]*/ BSTR * msg,/*[out,retval]*/ long * result);
	STDMETHOD(get_DownloadURL)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_DownloadURL)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_ScolVersionNeeded)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ScolVersionNeeded)(/*[in]*/ BSTR newVal);
	STDMETHOD(LaunchMachine)(/*[in]*/ BSTR * CmdLine,/*[in]*/ long CmdShow,/*[in]*/ long MemSize,/*[out,retval]*/ long * result);

/*	STDMETHOD(GetWindow)(struct HWND__ ** h)
  {
//		logit("GetWindow");
    *h=m_hWnd;
    return S_OK;
  }*/

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
	
	//char DebugBuf[1024];
	//sprintf(DebugBuf,"Ax Hwnd=%x",m_hWndCD);
	//::MessageBox(NULL,DebugBuf,"DEBUG",0);

		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("Scol ActiveX Plugin");
		//LPCTSTR pszText = _T(DebugBuf);
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}

	LRESULT OnMouseActivate(UINT, WPARAM, LPARAM, BOOL&)
	{
		// Manually activate the control
		InPlaceActivate(OLEIVERB_UIACTIVATE);

	   return S_OK;
	} 


};

#endif //__SCOLPLUGIN_H_


// Ptr to the unique instance of the PlugIn main class : 
// Used to map CallBack function to the class member function
extern CScolPlugin * MyScolPlugSingleton;
extern BOOL ScolQuit;
int MyCallBackForScol(char* Msg);
int MyEndCallBackForScol(int Reason);