// ScolInterface.h: interface for the ScolInterface class.
//
//////////////////////////////////////////////////////////////////////

#include <windows.h>

#include "ScolInstaller.h"

extern int NBPlugInstance;
extern int NBPlugFakeInstance;
extern BOOL ScolQuit;

#if !defined(AFX_SCOLINTERFACE_H__CC71D003_B23B_4BAD_B52C_6F969D6D6ADF__INCLUDED_)
#define AFX_SCOLINTERFACE_H__CC71D003_B23B_4BAD_B52C_6F969D6D6ADF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000




class ScolInterface  
{
public:
	ScolInterface();
	~ScolInterface();
	long LaunchMachine(const char *CmdLine, long CmdShow, long MemSize, HWND PlugWin);
	long SendMessageToScol(const char *StrMsg);
	void (*NSPrintStatus)(const char * Txt);
	void set_DownloadURL(char *DWURL);
	void set_DownloadSize(long Size);
	void set_ScolVersionNeeded(char *SVersion);
	void ForceInstall();
	char* get_DownloadURL();
	long get_DownloadSize();
	char* get_ScolVersionNeeded();
	void set_SendMessageCallBack(void * CB);
	void set_ScolEndCallBack(void * CB);

private:

	char m_strDownloadURL[1024];
	long m_longDownloadSize;
	char m_strScolVersionNeeded[1024];
	bool m_boolScolLoadSuccess;
	bool m_boolScolStartSuccess;
	bool m_boolForceInstall;
	bool m_boolFakeInstance;
	HWND m_hwnd;
	bool LoadScolLib();
	bool getScolDllname (char* path,char* name);
	void* m_ptrSendMsgCallBack;
	void* m_ptrEndScolCallBack;
	void SkipMessages();

	
};

#endif // !defined(AFX_SCOLINTERFACE_H__CC71D003_B23B_4BAD_B52C_6F969D6D6ADF__INCLUDED_)
