logComment("Start Install.js");

 // this function verifies disk space in kilobytes
 function verifyDiskSpace(dirPath, spaceRequired)
 {
   var spaceAvailable;
   // Get the available disk space on the given path
   spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

   // Convert the available disk space into kilobytes
   spaceAvailable = parseInt(spaceAvailable / 1024);
   // do the verification
   if(spaceAvailable < spaceRequired)
   {
      logComment("Insufficient disk space: " + dirPath);
      logComment("  required : " + spaceRequired + " K");
      logComment("  available: " + spaceAvailable + " K");
      return(false);
   }
   return(true);
 } 



// Main Installation Proc
var err;
var DestDir;
var PlugDll = "NPScol.dll";
var PlugXPT = "NPScol.xpt";

err = initInstall("Scol Netscape 6 PlugIn", "NPScol6", "6.0");
logComment("initInstall: " + err);

DestDir=getFolder("Components");
logComment("DestDir: " + DestDir);

if(verifyDiskSpace(DestDir, 50))
{
  setPackageFolder(DestDir);
  addFile(PlugDll);
  addFile(PlugXPT);
  // todo: Add XPCOM Registration 
  // not Available yet, but will be in Mozilla 1.0
  // -> For the moment need to restart the browser
  if (0 == getLastError())
	{
	Install.refreshPlugins();
	performInstall();
	}
  else
	cancelInstall();
}
else
{
 alert("Install need at least 50 Ko free on Hard Drive!");
 cancelInstall();
}